"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.reshape = reshape;
function reshape({
  source,
  shape
}) {
  const result = {};
  for (const key in shape) {
    if (!Object.prototype.hasOwnProperty.call(shape, key)) {
      continue;
    }
    const fn = shape[key];
    result[key] = source.map(state => {
      const result = fn(state);
      return result === undefined ? null : result;
    }, {
      skipVoid: false
    });
  }
  return result;
}